#!/bin/sh
# Copyright (c) 2020 Denis Kulakov <staticlinux@rambler.ru static@flibex.ru>
# SPDX-License-Identifier: GPL-2.0-only


#/mnt/mount_sdXY, reboot, shutdown for all
chmod 646 /sys/class/block/loop3/uevent


#Load keyboard keymap
loadkmap < /usr/share/keymaps/ru.bmap


#Changing the backlight by 50%
B_PATH=$(find /sys -type f -path "/sys/*drm*/brightness")
B_MAX=$(find /sys -type f -path "/sys/*drm*/max_brightness" -exec cat {} \;)
let "B_50 = 50 * B_MAX / 100"
echo $B_50 > $B_PATH


#seatd
umask 0000
seatd &
umask 0077


#Hostname
echo "Static" > /proc/sys/kernel/hostname


#----------Configure network----------
#eth0
ip link set lo up
ip link set dev eth0 up
#Static IP
#ip addr add 192.168.0.10/24 brd + dev eth0
#ip route add default via 192.168.0.1 dev eth0
#DHCP
udhcpc -b -i eth0 &


#wlan0
if [ -e /etc/wpa_supplicant/wpa_supplicant.conf ]; then
	ip link set wlan0 up
	wpa_supplicant -B -D nl80211 -i wlan0 -c /etc/wpa_supplicant/wpa_supplicant.conf
	udhcpc -b -i wlan0 &
fi


#Get NTP time
ntpd -n -p 0.ru.pool.ntp.org &


# make new /etc/machine-id
(SYMBOLS='0123456789abcdef'
uuid=""
for n in `seq 1 32`
do
uuid=$uuid${SYMBOLS:$(($RANDOM%16)):1}
done
echo $uuid > /etc/machine-id
chmod 644 /etc/machine-id) &


#upggrade world
[ -L /etc ] && apk.static -q upgrade
