#!/bin/sh
# Copyright (c) 2022 Denis Kulakov <staticlinux@rambler.ru static@flibex.ru>
# SPDX-License-Identifier: GPL-2.0-only


#Log to /tmp/hotplug.log
#exec 1>>/tmp/hotplug.log
#exec 2>>/tmp/hotplug.log


#Run udev emulation (hwdb_update)
[ "$SUBSYSTEM" = "input" ] && (
	[ ! -f /sys/class/block/loop3/uevent ] && sleep 2.$(($RANDOM%99))
	mkdir -p /run/udev/data; chmod 755 /run/udev; chmod 755 /run/udev/data
	for DIR in /sys/class/input/*/; do
		[ -f ${DIR}dev ] && (
			: > /run/udev/data/c$(cat ${DIR}dev)
			echo "E:ID_INPUT=1"
			[ -e ${DIR}device/mouse* ] && echo "E:ID_INPUT_MOUSE=1"
			[ -e ${DIR}device/*::capslock ] && echo "E:ID_INPUT_KEYBOARD=1"
			[ -f ${DIR}../uevent ] && (
				grep -q "Button" $DIR../uevent && echo "E:ID_INPUT_KEY=1"
				grep -q "Switch" $DIR../uevent && echo "E:ID_INPUT_SWITCH=1"
				grep -q "Touchpad" $DIR../uevent && echo "E:ID_INPUT_TOUCHPAD=1"
				grep -q "WebCam" $DIR../uevent && echo "E:ID_INPUT_KEY=1"
				)
			) > /run/udev/data/c$(cat ${DIR}dev)
		done
		chmod 644 /run/udev/data/*
	)


#Add partition or Mount
[ "$DEVTYPE" = "partition" -a "$ACTION" = "add" -o "$SYNTH_ARG_ACTION" = "mount" ] && (
	[ ! -f /sys/class/block/loop3/uevent ] && sleep 2.$(($RANDOM%99))
	umask 0000
	[ ! -z $SYNTH_ARG_DEVNAME ] && DEVNAME=$SYNTH_ARG_DEVNAME
	mkdir -p /mnt/$DEVNAME
	mount /dev/$DEVNAME /mnt/$DEVNAME -o nosuid,noatime && (
		rm -f /mnt/mount_$DEVNAME
cat <<END_TEXT > /mnt/umount_$DEVNAME
#!/bin/sh
echo "change 11111111-2222-3333-4444-555555555555 ACTION=umount DEVNAME=$DEVNAME" > /sys/class/block/loop3/uevent
END_TEXT
		chmod 755 /mnt/umount_$DEVNAME
		)
	)


#Remove partition
[ "$DEVTYPE" = "partition" -a "$ACTION" = "remove" ] &&	(
	rmdir /mnt/$DEVNAME
	rm -f /mnt/umount_$DEVNAME
	rm -f /mnt/mount_$DEVNAME
	)


#Umount
[ "$SYNTH_ARG_ACTION" = "umount" ] && (
	umount /mnt/$SYNTH_ARG_DEVNAME && (
		rm -f /mnt/umount_$SYNTH_ARG_DEVNAME
cat <<END_TEXT > /mnt/mount_$SYNTH_ARG_DEVNAME
#!/bin/sh
echo "change 11111111-2222-3333-4444-555555555555 ACTION=mount DEVNAME=$SYNTH_ARG_DEVNAME" > /sys/class/block/loop3/uevent
END_TEXT
		chmod 755 /mnt/mount_$SYNTH_ARG_DEVNAME
		)
	)


#Reboot
[ "$SYNTH_ARG_ACTION" = "reboot" ] && (	sync
					: > /run/initd_reboot
					#SIGTERM
					echo e > /proc/sysrq-trigger
					sleep 10
					)

#Shutdown
[ "$SYNTH_ARG_ACTION" = "shutdown" ] && ( sync
					#SIGTERM
					echo e > /proc/sysrq-trigger
					sleep 10
					)
